/*
 * VHitpoint - extended hit point information for picking in VRwave
 *
 * created: mpichler, 19970731
 *
 * changed: mpichler, 19970731
 * changed: apesen, 19970820
 *
 * $Id: VHitpoint.java,v 1.3 1997/08/21 14:16:14 apesen Exp $
 */


package iicm.vrml.vrwave;


import iicm.utils3d.Hitpoint;
import iicm.vrml.pw.GroupNode;

import java.util.Vector;

/**
 * VHitpoint - extended hit point information
 * Copyright (c) 1997 IICM
 */

public class VHitpoint extends Hitpoint
{
  public GroupNode hitparent_;  // parent of node hit
  public Vector hitpath_ = new Vector ();  // path from parent to root

  // note: knowing the parent of the node hit is *not* sufficient
  // to implement VRML pointing device sensors and Anchors;
  // a proper implementation must take into account nested groups
  // and will need the path to the node hit (TODO: apesen)

  public VHitpoint (int flags)
  {
    super (flags);
  }
} // VHitpoint
