# SGI make config settings
# included by SCO/makefile
#
# created: mpichler, 19960812
# changed: mpichler, 19961008

# use cc and ld instead of gcc (override config.defs settings)
# CC_PIC=gcc -belf -O2 -fpic -Wall
# CC_PIC=/udk/usr/ccs/bin/cc -V -belf -O2 -Kpic
CC_PIC=/udk/usr/ccs/bin/cc -V -32 -xansi -O2 -Kpic -D__LONGLONG

# java system inlcude files (*_md.h)
# SYSINC=-I/usr/java/include/unixware -I/udk/usr/include -I/udk/usr/ucbinclude
SYSINC=-I/usr/java/include/unixware

# java include path
JAVAINC=-I/usr/java/include $(SYSINC)

# any extra compiler flags
CCDEFS=-DSCO -DSYSV -D_OSF1_SOURCE -DINSTCOLORMAP -DGE3D_PROTOTYPES -I/udk/usr/include

# X11 libraries
# XLIBDIR=-L/usr/lib/X11 -lXmu -lX11 -lm -lsocket -lnsl
XLIBDIR=-L/udk/usr/lib -L/udk/usr/lib/X11 -L/usr/lib/X11 -lXmu -lX11 -lm -lsocket -lnsl

# override setting in config.defs
# LDSO=gcc -shared
# LDSO=gcc -symbolic
# LDSO=gcc -belf -G -O2 -fpic
# LDSO=/udk/usr/ccs/bin/cc -V -belf -O2 -G -Kpic
LDSO=/udk/usr/ccs/bin/cc -V -O2 -32 -G -Kpic

# java able to resolve its own libs (-Xlinker assumes gcc calling linker)
LDSOLIBS=-lsocket -lnsl

# include either config.Mesa or config.OpenGL
include ../config.Mesa
# include ../config.OpenGL

# path to OpenGL include files (need not be set if under /usr/include)
OGLINC=-I/usr/local/include -I/usr/local/include/mesa

# Mesa/OpenGL library
MESALIBDIR=-L/usr/local/lib
# OGLLIB=$(MESALIBDIR) -lMesaGLU -lMesaGL -lMesaaux -lMesatk -lXext
OGLLIB=$(MESALIBDIR) -lMesaGLU -lMesaGL -lXext
