#if 0
//<copyright>
//
// Copyright (c) 1992,93,94,95
// Institute for Information Processing and Computer Supported New Media (IICM),
// Graz University of Technology, Austria.
//
// This file is part of VRweb.
//
// VRweb is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// VRweb is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with VRweb; see the file LICENCE. If not, write to the
// Free Software Foundation, Inc., 59 Temple Place - Suite 330,
// Boston, MA 02111-1307, USA.
//
//</copyright>
#endif

/*
 * File:     face.h
 *
 * Author:   Michael Hofer (until May 92) and Michael Pichler
 *
 * Created:   2 Apr 92
 *
 * Changed:  30 Jan 95
 *
 * $Id: face.h,v 1.2 1996/06/03 17:23:43 mpichler Exp $
 *
 */


#ifndef ge3d_face_h
#define ge3d_face_h


#include "vectors.h"


typedef struct
{
  int num_faceverts,     /* number of vertices in face */
      num_facenormals,   /* number of normals in face */
      num_facetexverts;  /* number of texture verts in face */
  int *facevert,         /* array of indices of the vertices, ... */
      *facenormal,       /* ... and of the normals, ... */
      *facetexvert;      /* ... and texture vertices of the face */
  vector3D normal;       /* normalized, outward face normal */
} face;


#endif
